Subject: Re: bug#19760: [bug] "tail -f" with inotify fails to follow a file after a rename()

From: Pádraig Brady <[email-masked]>
Date: Tue, 31 Mar 2015 04:15:27 +0100

On 03/02/15 23:30, Pádraig Brady wrote:
> On 03/02/15 22:04, Stephane Chazelas wrote:
>> Hello,
>>
>> On Linux, when inotify is used,
>>
>>    tail -f file
>>
>> follows a file only until it's renamed. After it is renamed, the
>> inotify watch is removed, which means tail sits there doing
>> nothing and any further modifications to the file are ignored.
>>
>> To reproduce:
>>
>>     echo 1 > file
>>     tail -f file &
>>     exec 3>> file
>>     echo 2 >&3
>>     sleep 1
>>     mv file file2
>>     sleep 1
>>     echo 3 >&3
>>     sleep 1
>>     : > file2
>>
>> "3" is not displayed. No message about the file being truncated
>> either.
>>
>> Work arounds:
>>
>>    tail ---disable-inotify -f file
>>    tail -f < file # effectively disables inotify
>>
>>    or rename the file with a link() followed by an unlink()
>>    ln file newfile && rm -f file
>>
>> Note that the IN_DELETED_SELF event is not reached in
>> follow-descriptor mode because tail has the file open preventing
>> it from being deleted even after it's unlinked from the last
>> directory.
>>
>> Patch attached (on the current git head).
> 
> Ouch. The patch makes sense on first glance,
> and all existing tests pass with it.
> I'll check some more and add a test.

Sorry for the delay.
I'll apply the attached in your name soon.

thanks,
Pádraig.

>From 9c23049e17a76f4ec8f38c04b088f149a49b4851 Mon Sep 17 00:00:00 2001
From: Stephane Chazelas <[email-masked]>
Date: Tue, 3 Feb 2015 21:22:06 +0000
Subject: [PATCH] tail: fix -f to follow changes after a rename

* src/tail.c (tail_forever_inotify): Only monitor write()s and
truncate()s to files in --follow=descriptor mode, thus avoiding
the bug where we removed the watch on renamed files.
Also adjust the inotify event processing code which
that is now significant only in --follow=name mode.
* tests/tail-2/f-vs-rename.sh: A new test.
* tests/local.mk: Reference the new test.
* NEWS: Mention the bug.
Fixes http://bugs.gnu.org/19760
---
 NEWS                        |  3 +++
 src/tail.c                  | 31 +++++++++++++--------------
 tests/local.mk              |  1 +
 tests/tail-2/f-vs-rename.sh | 51 +++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 69 insertions(+), 17 deletions(-)
 create mode 100755 tests/tail-2/f-vs-rename.sh

diff --git a/NEWS b/NEWS
index 81031c6..214db08 100644
--- a/NEWS
+++ b/NEWS
@@ -39,6 +39,9 @@ GNU coreutils NEWS                                    -*- outline -*-
   resources with many files, or with -F if files were replaced many times.
   [bug introduced in coreutils-7.5]
 
+  tail -f continues to follow changes to a file even after it's renamed.
+  [bug introduced in coreutils-7.5]
+
 ** New features
 
   chroot accepts the new --skip-chdir option to not change the working directory
diff --git a/src/tail.c b/src/tail.c
index c5380cb..f75d7a9 100644
--- a/src/tail.c
+++ b/src/tail.c
@@ -159,13 +159,6 @@ struct File_spec
   uintmax_t n_unchanged_stats;
 };
 
-#if HAVE_INOTIFY
-/* The events mask used with inotify on files.  This mask is not used on
-   directories.  */
-static const uint32_t inotify_wd_mask = (IN_MODIFY | IN_ATTRIB
-                                         | IN_DELETE_SELF | IN_MOVE_SELF);
-#endif
-
 /* Keep trying to open a file even if it is inaccessible when tail starts
    or if it becomes inaccessible later -- useful only with -f.  */
 static bool reopen_inaccessible_files;
@@ -1390,6 +1383,13 @@ tail_forever_inotify (int wd, struct File_spec *f, size_t n_files,
   if (! wd_to_name)
     xalloc_die ();
 
+  /* The events mask used with inotify on files (not directories).  */
+  uint32_t inotify_wd_mask = IN_MODIFY;
+  /* TODO: Perhaps monitor these events in Follow_descriptor mode also,
+     to tag reported file names with "deleted", "moved" etc.  */
+  if (follow_mode == Follow_name)
+    inotify_wd_mask |= (IN_ATTRIB | IN_DELETE_SELF | IN_MOVE_SELF);
+
   /* Add an inotify watch for each watched file.  If -F is specified then watch
      its parent directory too, in this way when they re-appear we can add them
      again to the watch list.  */
@@ -1641,20 +1641,17 @@ tail_forever_inotify (int wd, struct File_spec *f, size_t n_files,
 
       if (ev->mask & (IN_ATTRIB | IN_DELETE_SELF | IN_MOVE_SELF))
         {
-          /* For IN_DELETE_SELF, we always want to remove the watch.
-             However, for IN_MOVE_SELF (the file we're watching has
-             been clobbered via a rename), when tailing by NAME, we
-             must continue to watch the file.  It's only when following
-             by file descriptor that we must remove the watch.  */
-          if ((ev->mask & IN_DELETE_SELF)
-              || ((ev->mask & IN_MOVE_SELF)
-                  && follow_mode == Follow_descriptor))
+          /* Note for IN_MOVE_SELF (the file we're watching has
+             been clobbered via a rename) we leave the watch
+             in place since it may still be part of the set
+             of watched names.  */
+          if (ev->mask & IN_DELETE_SELF)
             {
               inotify_rm_watch (wd, fspec->wd);
               hash_delete (wd_to_name, fspec);
             }
-          if (follow_mode == Follow_name)
-            recheck (fspec, false);
+
+          recheck (fspec, false);
 
           continue;
         }
diff --git a/tests/local.mk b/tests/local.mk
index 56cba69..1be31ad 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -171,6 +171,7 @@ all_tests =					\
   tests/tail-2/inotify-hash-abuse2.sh		\
   tests/tail-2/F-vs-missing.sh			\
   tests/tail-2/F-vs-rename.sh			\
+  tests/tail-2/f-vs-rename.sh			\
   tests/tail-2/inotify-rotate.sh		\
   tests/tail-2/inotify-rotate-resources.sh	\
   tests/chmod/no-x.sh				\
diff --git a/tests/tail-2/f-vs-rename.sh b/tests/tail-2/f-vs-rename.sh
new file mode 100755
index 0000000..efb0a40
--- /dev/null
+++ b/tests/tail-2/f-vs-rename.sh
@@ -0,0 +1,51 @@
+#!/bin/sh
+# demonstrate that tail -f works when renaming the tailed files
+# Before coreutils-8.24, tail -f a would stop tracking additions to b
+# after "mv a b".
+
+# Copyright (C) 2015 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ tail
+
+touch a || framework_failure_
+
+debug='---disable-inotify'
+debug=
+tail $debug -f -s.1 a > out 2>&1 & pid=$!
+
+check_tail_output()
+{
+  local delay="$1"
+  grep "$tail_re" out > /dev/null ||
+    { sleep $delay; return 1; }
+}
+
+# Wait up to 12.7s for tail to start
+echo x > a
+tail_re='^x$' retry_delay_ check_tail_output .1 7 || fail=1
+
+mv a b || fail=1
+
+echo y >> b
+# Wait up to 12.7s for "y" to appear in the output:
+tail_re='^y$' retry_delay_ check_tail_output .1 7 || fail=1
+
+kill $pid
+
+wait
+
+Exit $fail
-- 
2.1.0